---
title: ContentIndex.getAll()
slug: Web/API/ContentIndex/getAll
tags:
  - Content
  - Content Index API
  - Index
  - Interface
  - Method
  - PWA
  - content indexing
  - getAll
---
<div>{{draft}}{{DefaultAPISidebar("Content Index API")}}</div>

<p class="summary">The <strong><code>getAll()</code></strong> method of the {{domxref("ContentIndex")}} interface returns a {{jsxref('Promise')}} that resolves with an iterable list of content index entries.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>indexedContent</var> = ContentIndex.getAll();</pre>

<h3 id="Parameters">Parameters</h3>

<p>This method receives no parameters.</p>

<h3 id="Return_value">Return value</h3>

<p>Returns a {{jsxref("Promise")}} that resolves with an {{jsxref('Array')}} of <code>ContentDescription</code> items.</p>

<dl>
 <dt><em>ContentDescription</em></dt>
 <dd>Each item returned is an {{jsxref('Object')}} containing the following data:
 <ul>
  <li><code>id</code>: A unique {{jsxref('String')}} identifier.</li>
  <li><code>title</code>: A {{jsxref('String')}} title for the item. Used in user-visible lists of content.</li>
  <li><code>title</code>: A {{jsxref('String')}} title of the item. Used in user-visible lists of content.</li>
  <li><code>description</code>: A {{jsxref('String')}} description of the item. Used in user-visible lists of content.</li>
  <li><code>url</code>: A {{jsxref('String')}} containing the url of the corresponding HTML document. Needs to be under the scope of the current {{domxref('ServiceWorker','service worker')}}.</li>
  <li><code>category</code>: {{Optional_Inline}} A {{jsxref('String')}} defining the category of content. Can be:
   <ul>
    <li><code>''</code> An empty {{jsxref('String')}}, this is the default.</li>
    <li><code>homepage</code></li>
    <li><code>article</code></li>
    <li><code>video</code></li>
    <li><code>audio</code></li>
   </ul>
  </li>
  <li><code>icons</code>: {{Optional_Inline}} An {{jsxref('Array')}} of image resources, defined as an {{jsxref('Object')}} with the following data:
   <ul>
    <li><code>src:</code> A url {{jsxref('String')}} of the source image.</li>
    <li><code>sizes:</code> {{Optional_Inline}} A {{jsxref('String')}} representation of the image size.</li>
    <li><code>type:</code> {{Optional_Inline}} The {{Glossary("MIME type")}} of the image.</li>
   </ul>
  </li>
 </ul>
 </dd>
</dl>

<h3 id="Exceptions">Exceptions</h3>

<p>No exceptions are thrown. If there are no items in the Content Index, an empty {{jsxref('Array')}} is returned.</p>

<h2 id="Examples">Examples</h2>

<p>The below example shows an asynchronous function that retrieves items within the {{domxref('Content Index API','content index')}} and iterates over each entry, building a list for the interface.</p>

<pre class="brush: js notranslate">async function createReadingList() {
  // access our service worker registration
  const registration = await navigator.serviceWorker.ready;

  // get our index entries
  const entries = await registration.index.getAll();

  // create a containing element
  const readingListElem = document.createElement('div');

  // test for entries
  if (!Array.length) {

    // if there are no entries, display a message
    const message = document.createElement('p');
    message.innerText = 'You currently have no articles saved for offline reading.'

    readingListElem.append(message);

  } else {

    // if entries are present, display in a list of links to the content
    const listElem = document.createElement('ul');

    for (const entry of entries) {
      const listItem = document.createElement('li');

      const anchorElem = document.createElement('a');
      anchorElem.innerText = entry.title;
      anchorElem.setAttribute('href', entry.url);

      listElem.append(listItem);

    }

    readingListElem.append(listElem);
  }

}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Content Index API','#dom-contentindex-getall','getAll')}}</td>
   <td>{{Spec2('Content Index API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ContentIndex.getAll")}}</p>

<h2 id="See_also">See also:</h2>

<ul>
 <li><a href="https://web.dev/content-indexing-api/">An introductory article on the Content Index API</a></li>
 <li><a href="https://contentindex.dev/">An app which uses the Content Index API to list and remove 'save for later' content</a></li>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API, along with information about Cache and CacheStorage</a></li>
</ul>
